<template>
  <section class="section">
    <h1 class="mb-4">
      Results
    </h1>

    <template v-if="hasSentences">
      <label class="cursor-pointer flex my-2">
        Display normal rows
        <input
          v-model="showRows"
          class="ml-2"
          type="checkbox"
        >
      </label>

      <label class="cursor-pointer flex my-2">
        Display sentences (experimental)
        <input
          v-model="showSentences"
          class="ml-2"
          type="checkbox"
        >
      </label>
    </template>

    <section class="content">
      <table class="table">
        <thead class="font-bold text-center">
          <tr>
            <td>Ballots</td>
            <td>Group A</td>
            <td>Group B</td>
          </tr>
        </thead>
        <tbody>
          <tr>
            <td>
              <ViewRules
                v-if="contextRulesWithType.length > 0"
                :rules="contextRulesWithType"
              />

              <p v-else>
                All the ballots
              </p>
            </td>

            <td>
              <ViewRules
                v-if="g1RulesWithType.length > 0"
                :rules="g1RulesWithType"
              />

              <p v-else>
                Everybody
              </p>
            </td>

            <td>
              <ViewRules
                v-if="g2RulesWithType.length > 0"
                :rules="g2RulesWithType"
              />

              <p v-else>
                Everybody
              </p>
            </td>
          </tr>
        </tbody>
      </table>

      <p class="my-4">
        {{ rows.length }} patterns found.
        <template v-if="filteredRows.length < rows.length">
          ({{ filteredRows.length }} shown)
        </template>
      </p>

      <button
        class="btn mb-4"
        @click="showTransparency = true"
      >
        Oh yeah?
      </button>

      <table class="border-collapse w-full table">
        <thead v-if="showRows">
          <tr class="bg-grey-lighter">
            <th
              v-for="column of columns"
              v-show="!column.hidden"
              :key="column.field"
              scope="col"
              class="border relative cursor-pointer p-2 px-6"
              @click="sortBy(column)"
            >
              <p class="flex-grow text-center">
                {{ column.label }}
              </p>

              <icon
                v-if="sortColumn === column"
                style="right: .5rem;"
                scale="1"
                class="absolute-center-vertical text-grey-dark"
                :name="invertSort ? 'arrow-down' : 'arrow-up'"
              />
            </th>
          </tr>

          <tr>
            <td
              v-for="column of columns"
              v-show="!column.hidden"
              :key="column.field"
            >
              <input
                v-show="displayFilterInput(column.field)"
                v-model="filters[column.field]"
              >
            </td>
          </tr>
        </thead>

        <tbody
          v-for="row of sortedRows"
          :key="row.index"
          class="border transition alternate-background hover:bg-blue-lighter cursor-pointer"
          @click="showDetails({ row })"
        >
          <tr v-if="showRows">
            <td
              class="border p-2"
            >
              <div
                class="border border-grey-dark bg-red-lightest rounded-full border-light-gray overflow-hidden"
                style="min-width: 16rem; position: relative;"
              >
                <div
                  class="h-full bg-red"
                  :style="row.pattern.style_context_bar"
                  :title="row.pattern.ref_sim_100"
                />
                <div
                  class="text-center text-white font-bold f6 h-4"
                  role="progressbar"
                  :style="row.pattern.style_progress"
                />
              </div>

              <p class="my-4">
                Usual agreement: {{ row.pattern.refSim | percentage }}<br>
                Context agreement: {{ row.pattern.patternSim | percentage }}<br>
              </p>

              <p>
                Intensity: {{ row.pattern.quality | percentage }}
              </p>
            </td>

            <td class="text-center border">
              {{ row.change | percentage }}
            </td>

            <td class="border p-2">
              <ul class="list-reset">
                <li
                  v-for="[param, value] of row.g1"
                  :key="param"
                  class="my-4"
                >
                  <div class="text-xs">
                    {{ param }}:
                  </div>
                  {{ value }}
                </li>
              </ul>
            </td>

            <td class="border p-2">
              <ul class="list-reset">
                <li
                  v-for="[param, value] of row.g2"
                  :key="param"
                  class="my-4"
                >
                  <div class="text-xs">
                    {{ param }}:
                  </div>
                  {{ value }}
                </li>
              </ul>
            </td>

            <td class="border p-2">
              <ul class="list-reset">
                <li
                  v-for="[param, data] of row.context"
                  :key="param"
                  class="my-4"
                >
                  <div class="text-xs">
                    {{ param }}:
                  </div>

                  <ul
                    v-if="typeof data == 'object'"
                    style="list-style: '– '"
                  >
                    <li
                      v-for="value of data"
                      :key="value"
                    >
                      {{ value }}
                    </li>
                  </ul>

                  <p v-else>
                    {{ data }}
                  </p>
                </li>
              </ul>
            </td>
          </tr>

          <tr v-if="showSentences">
            <td
              :colspan="columns.length"
              class="whitespace-pre p-4"
              v-html="results[row.index - 1].sentence.trim()"
            />
          </tr>
        </tbody>
      </table>
    </section>

    <modal v-model="showTransparency">
      <Transparency
        :transparency-html="transparencyHtml"
        :transparency-data="transparencyData"
      />
    </modal>

    <modal v-model="showModal">
      <DetailedResultsInter
        v-if="config.dataset"
        class="p-4"
        :pattern="selected_result"
        :data-type="config.dataset.type"
      />
    </modal>
  </section>
</template>

<style lang="postcss" scoped>
.vgt-table thead th {
  vertical-align: middle;
}

.absolute-center-vertical {
  position: absolute;
  top: 50%;
  transform: translateY(-50%);
}

.alternate-background:nth-child(odd):not(:hover) {
  @apply bg-grey-lighter;
}

.table {
  td {
    @apply border p-2;
  }
}
</style>

<script lang="ts">
import { Vue, Component, Prop } from 'vue-property-decorator'
import { State } from 'vuex-class'

import 'vue-awesome/icons/arrow-up'
import 'vue-awesome/icons/arrow-down'
import Icon from 'vue-awesome/components/Icon.vue'

import DetailedResultsInter from '@/components/DetailedResultsInter.vue'
import Transparency from '@/components/Transparency.vue'
import Modal from '@/components/Modal.vue'
import ViewRules from '@/components/ViewRules.vue'

import _ from 'lodash/fp'

function colorPercentage ([r1, g1, b1], [r2, g2, b2], percentage) {
  const percent = (a, b) => a + (b - a) * percentage
  return [percent(r1, r2), percent(g1, g2), percent(b1, b2)]
}

function percentage (val) {
  return `${_.round(_.multiply(100, val))}%`
}

function displayRow ({ index, context, g1, g2, refSim, patternSim, quality }) {
  return {
    index,
    pattern: {
      refSim,
      patternSim,
      style_context_bar: `width: 3px; position: absolute; left: ${percentage(refSim)};`,
      style_progress: `width: ${percentage(patternSim)}; background: rgb(${colorPercentage([221, 75, 57], [0, 166, 90], patternSim).join(',')});`,
      quality: Number.parseFloat(quality)
    },
    change: (patternSim - refSim) / refSim,
    g1,
    g2,
    context
  }
}

const ruleTypes = [
  'inSet',
  'outSet',
  'inInterval',
  'outInterval',
  'lowerThan',
  'greaterThan',
  'contain_themes'
]

const getRuleType = _.compose([
  _.find((key) => (_.includes)(key)(ruleTypes)),
  _.keys])

const columns = [
  {
    hidden: true,
    field: 'index'
  },
  {
    label: 'Agreement-O-Meter',
    field: 'pattern',
    html: true,
    sortFn: _.get('pattern.quality')
  },
  {
    type: 'number',
    field: 'change',
    label: 'Relative change',
    sortFn: _.compose(Math.abs, _.get('change'))
  },
  {
    label: 'Group A',
    field: 'g1',
    html: true,
    sortFn: _.compose(JSON.stringify, _.get('g1')),
    filterOptions: {
      enabled: true
    }
  },
  {
    label: 'Group B',
    field: 'g2',
    html: true,
    sortFn: _.compose(JSON.stringify, _.get('g2')),
    filterOptions: {
      enabled: true
    }
  },
  {
    label: 'Context',
    field: 'context',
    html: true,
    sortFn: _.get('context'),
    filterOptions: {
      enabled: true
    }
  }
]

@Component({
  components: {
    DetailedResultsInter,
    Icon,
    Modal,
    Transparency,
    ViewRules
  }
})
export default class ResultsInter extends Vue {
  get rows () {
    return _.map(displayRow, this.results)
  }

  get keysToFilterBy () {
    return _.map(_.get('field'))(_.filter(_.getOr(false, 'filterOptions.enabled'))(this.columns))
  }

  get filteredRows () {
    const checkRow = (row) => (key) => _.contains(_.toLower(_.getOr('', key, this.filters) as any as string), _.toLower(JSON.stringify(row[key])))

    return _.filter((row) => _.every(checkRow(row))(this.keysToFilterBy), this.rows)
  }

  get sortedRows () {
    const mapped = this.filteredRows.map((row, index) => ({ index, value: this.sortColumn.sortFn(row) }), this.rows)
    mapped.sort((a, b) => {
      if (a.value > b.value) {
        return 1
      } else if (a.value < b.value) {
        return -1
      } else {
        return 0
      }
    })

    if (this.invertSort) {
      mapped.reverse()
    }

    return _.map(({ index }) => this.filteredRows[index], mapped)
  }

  get contextRulesWithType () {
    return _.zip(this.config.contexts_scope, _.map(getRuleType, this.config.contexts_scope))
  }

  get g1RulesWithType () {
    return _.zip(this.config.individuals_1_scope, _.map(getRuleType, this.config.individuals_1_scope))
  }

  get g2RulesWithType () {
    return _.zip(this.config.individuals_2_scope, _.map(getRuleType, this.config.individuals_2_scope))
  }

  @Prop(Object) config
  @Prop(Object) transparencyData
  @Prop(String) transparencyHtml
  @Prop(Array) results

  @State userID
  @State jobID

  columns = columns
  filters = {}
  selected_result = []
  showModal = false
  showTransparency = false
  sortColumn = columns[1]
  invertSort = true
  showSentences = false
  showRows = true

  colorPercentage

  sortBy (column) {
    if (this.sortColumn === column) {
      this.invertSort = !this.invertSort
    } else {
      this.invertSort = false
      this.sortColumn = column
    }
  }

  displayFilterInput (key) {
    return _.contains(key, this.keysToFilterBy)
  }

  showDetails ({
    row: {
      index
    }
  }) {
    this.selected_result = _.find(_.matchesProperty('index', index), this.results)
    this.showModal = true
  }

  get hasSentences () {
    return _.has('sentence', _.first(this.results))
  }
}
</script>
